import * as React from "react";
export interface IAutoCompleteOption {
    id: number;
    name: string;
    data?: any;
}
export interface IAutoCompleteInputProps extends React.Props<AutoCompleteInput> {
    className?: string;
    value?: IAutoCompleteOption | IAutoCompleteOption[];
    minimumLength?: number;
    placeholder?: string;
    searchPlaceholder?: string;
    noResultsMessage?: string;
    options?: IAutoCompleteOption[];
    remoteThrottle?: number;
    remoteQuery?: (query: string) => Promise<IAutoCompleteOption[]>;
    remoteQueryOnOpen?: boolean;
    hasGoButton?: boolean;
    goButtonContent?: React.ReactElement<any> | string;
    onSelected?: (selectedOption: IAutoCompleteOption | IAutoCompleteOption[]) => void;
    visibleItems?: number;
    canClear?: boolean;
    disabled?: boolean;
    multiSelect?: boolean;
    icon?: string;
}
export interface IAutoCompleteInputState {
    filteredOptions?: IAutoCompleteOption[];
    query?: string;
    open?: boolean;
    selectedValue?: IAutoCompleteOption | IAutoCompleteOption[];
    selectedIndex?: number;
    remoteSearching?: boolean;
    offsetIndex?: number;
    showOnTop?: boolean;
    topOffset?: number;
}
export declare class AutoCompleteInput extends React.Component<IAutoCompleteInputProps, IAutoCompleteInputState> {
    private timer;
    private itemHeight;
    static defaultProps: {
        remoteThrottle: number;
        minimumLength: number;
    };
    constructor(props: IAutoCompleteInputProps);
    filterRemote(query: string, immediate?: boolean): void;
    filter(query: string): void;
    focusInput(e: any): void;
    handleEvent(e: any): void;
    componentWillMount(): void;
    componentWillReceiveProps(newProps: IAutoCompleteInputProps): void;
    shouldShowOnTop(): boolean;
    checkKey(e: any): boolean;
    constrainIndex(): void;
    private isArray<T>(itemOrArray);
    handleSelection(options: IAutoCompleteOption | IAutoCompleteOption[]): void;
    buttonClick(): void;
    render(): JSX.Element;
}
